import { CallHandler, ExecutionContext, NestInterceptor } from '@nestjs/common';
import { Observable } from 'rxjs';
import { EntityType } from '../types/entity.type';
import { BaseEntity } from '../interfaces/base-entity.interface';
import { IMetaObject, IResponseObject } from '../interfaces/response';
export interface IEntitySerializerOptions {
    jsonApiEnabled?: boolean;
    jsonApiMetaData?: IMetaObject;
}
export declare class EntitySerializerInterceptor<T extends BaseEntity> implements NestInterceptor<T, IResponseObject<T>> {
    private type;
    private options;
    constructor(type: EntityType<T>, options?: IEntitySerializerOptions);
    intercept(context: ExecutionContext, next: CallHandler): Observable<IResponseObject<T>>;
}
//# sourceMappingURL=entity-serializer.interceptor.d.ts.map