"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntitySerializerInterceptor = void 0;
const common_1 = require("@nestjs/common");
const operators_1 = require("rxjs/operators");
const resource_serializer_1 = require("../serializers/resource.serializer");
let EntitySerializerInterceptor = class EntitySerializerInterceptor {
    constructor(type, options = { jsonApiEnabled: true }) {
        this.type = type;
        this.options = options;
    }
    intercept(context, next) {
        return next.handle().pipe(operators_1.map(data => {
            const response = {};
            /* Property: 'data' */
            if (Array.isArray(data)) {
                const serializer = new resource_serializer_1.ResourceSerializer(this.type);
                response.data = serializer.handleMany(data);
            }
            else {
                const serializer = new resource_serializer_1.ResourceSerializer(this.type);
                response.data = serializer.handleOne(data);
            }
            /* Property: 'jsonapi' */
            if (this.options.jsonApiEnabled) {
                const jsonapi = { version: '1.0', meta: this.options.jsonApiMetaData };
                response.jsonapi = jsonapi;
            }
            return response;
        }));
    }
};
EntitySerializerInterceptor = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [Object, Object])
], EntitySerializerInterceptor);
exports.EntitySerializerInterceptor = EntitySerializerInterceptor;
//# sourceMappingURL=entity-serializer.interceptor.js.map