import 'reflect-metadata';

import { EntityType } from '../types/entity.type';

export interface IRelationOptions {
  name: string;
  type: EntityType<any>;
}

export const Relation = (options: IRelationOptions): PropertyDecorator => {
  return (target: Object, property: string | symbol) => {
    const metadata = Reflect.getMetadata('SERIALIZER_RELATION', target.constructor) || {};
    metadata[property] = options;
    Reflect.defineMetadata('SERIALIZER_RELATION', metadata, target.constructor);
  };
};