import { IRelationshipObject, ILinksObject, IMetaObject } from '..';

export type IAttributesObject<T> = Omit<T, 'id'>;

export type IRelationshipsObject<T> = { [key: string]: IRelationshipObject<T> };

export type IResourceLinksObject = Pick<ILinksObject, 'self' | 'related'>;

export interface IResourceObject<T> {
  /*
   * Required Members
   */
  id: string;
  type: string;

  /*
   * Optional Members
   */
  attributes?: IAttributesObject<T>;
  relationships?: IRelationshipsObject<T>;
  links?: IResourceLinksObject;
  meta?: IMetaObject;
}