import { IErrorObject, IJSONAPIObject, ILinksObject, IMetaObject, IResourceIdentifierObject, IResourceObject } from '..';

export type IResponseLinksObject = Omit<ILinksObject, 'about'>

export interface IResponseObject<T> {
  /*
   * Optional Members (1 Required)
   */
  data?: IResourceObject<T> | IResourceIdentifierObject<T> | null | IResourceObject<T>[] | IResourceIdentifierObject<T>[] | [];
  errors?: IErrorObject[];
  meta?: IMetaObject;

  /*
   * Optional Members
   */
  jsonapi?: IJSONAPIObject;
  links?: IResponseLinksObject;
  included?: IResourceObject<any>[];
}